const UpdaterService = require('../service/UpdaterService');
const serverConfig = require('../../../config/ServerConfig');
const path = require('path');
const fs = require('fs');

class UpdaterControllerEx {
  constructor() {};      

  async installVersion(req, res) {
    const data = req.body;

    const response = await UpdaterService.insertEventTable(
      data.CDFILIAL,
      data.DEVOPSID,
      data.INSTALLVERSION,
      data.CREATENEWVERSION,
      'INSTALACAO_PENDENTE'
    );
    
    res.send(response);
  }

  async removeVersion(req, res) {
    const data = req.body;

    const response = await UpdaterService.insertEventTable(
      data.CDFILIAL,
      data.DEVOPSID,
      data.INSTALLVERSION,
      data.CREATENEWVERSION,
      'REMOCAO_PENDENTE'
    );
    
    res.send(response);
  }

  async installVersionInProgress(req, res) {
    const data = req.body;

    const response = await UpdaterService.updateEventTable(
      data.CDFILIAL,
      data.DEVOPSID,
      data.INSTALLVERSION,
      data.CREATENEWVERSION,
      'INSTALACAO_EM_CURSO'
    );
    
    res.send(response);
  }

  async removeVersionInProgress(req, res) {
    const data = req.body;

    const response = await UpdaterService.updateEventTable(
      data.CDFILIAL,
      data.DEVOPSID,
      data.INSTALLVERSION,
      data.CREATENEWVERSION,
      'REMOCAO_EM_CURSO'
    );
    
    res.send(response);
  }

  async finishUpdater(req, res) {
    const data = req.body;

    const response = await UpdaterService.finishEventTable(
      data.CDFILIAL,
      data.DEVOPSID,
      data.INSTALLVERSION,
      data.CREATENEWVERSION
    );

    await UpdaterService.updateProdFiliVersion(
      data.UPDATEVERSION,
      data.CDFILIAL,
      data.DEVOPSID,
    );

    res.send(response);
  }

  async cancelUpdater(req, res) {
    const data = req.body;

    const response = await UpdaterService.cancelEventTable(
      data.CDFILIAL,
      data.DEVOPSID,
      data.INSTALLVERSION,
      data.CREATENEWVERSION
    );
    
    res.send(response);
  }
  
  async cancelUnitEvents(req, res) {
    const data = req.body;

    const response = await UpdaterService.cancelUnitEvents(
      data.CDFILIAL
    );
    
    res.send(response);
  }

  async getPendingEvents(req, res) {
    const pendingEvents = await UpdaterService.getPendingEvents();
    
    const response = {
      error: true,
      message: '',
      data: {}
    };

    if (pendingEvents.rows.length) {
      response.error = false;
      response.message = '';
      response.data = pendingEvents.rows;
    }

    res.send(response);
  }

  async getPendingEventsByUnit(req, res) {
    const data = req.body;

    const pendingEvents = await UpdaterService.getPendingEventsByUnit(data.CDFILIAL);
    
    const response = {
      error: true,
      message: '',
      events: {}
    };

    if (pendingEvents.rows.length) {
      response.error = false;
      response.message = '';
      response.events = pendingEvents.rows;
    }

    res.send(response);
  }

  async getAvailablePackages(req, res) {
    const data = req.body;
    const extension = 'tar.gz';
    
    const packageURL = `${serverConfig.packageServer}/${data.DIRECTORY}/${data.VERSION}.${extension}`

    res.send({url: packageURL});
  }
}

module.exports = new UpdaterControllerEx()