const cors = require('cors');
const bodyParser = require('body-parser');
const express = require('express');
const path = require('path');
const consign = require('consign');

const app = express();

app.use(cors());
app.use(express.json());
app.use(express.urlencoded({ extended: false }));
app.use(bodyParser.json({ limit: '50mb' }));

consign({ cwd: 'app' });
consign({ cwd: path.resolve(__dirname, '../../'), loggin: false, verbose: false })
  .then('middleware')
  .then('logs')
  .then('model')
  .then('controller')
  .then('service')
  .then('routes')
  .into(app);

const setupRoutes = require('./routes');
const setupErrors = require('./errors');

setupRoutes(app);
setupErrors(app);

app.use(express.static(path.resolve(__dirname, '../../../../frontend/dist')));
app.use('*', express.static(path.resolve(__dirname, '../../../../frontend/dist')));

module.exports = app;