class StructureModel {
    constructor() {

        this.TABLE_NAMES = `'TIPOCONSCLI', 'CONSUMIDOR', 'CLIENFILIAL', 'PRODLOJA', 'GRUPPROD', 'GRUPOCOR', 'OCORRENCIA', 'PRODOCORRE', 'FERIFILI', 'NOVOCODIGO', 'IMPOSTO', 'TABEPREC', 'TABEVEND', 'PARAMGERAL', 'UNIDMEDIDA', 'TIPORECE', 'OPERADOR', 'OPERGRUPOP', 'FILIAL', 'FILIOPER', 'CAIXA', 'CLIENTE', 'LOJA', 'CONFTELA', 'PRODUTO', 'ITEMPRECO', 'MOVINDICE', 'PARAVEND', 'ROTFABRICA', 'ALIQIMPFIS', 'ITEMPRECODIA', 'ITMENUCONFTE', 'CDBARRAPROD', 'TURCAIXA', 'VENDA', 'REDUCAOZ', 'MOVCAIXA', 'ITEMVENDA', 'MOVICLIE', 'IMPOSTOREDZ', 'TOTNFISCREDZ', 'FORMPGTOREDZ', 'ITVENDAIMPOS', 'ITVENDACAN', 'COMANDACXA', 'ITCOMANDACXA', 'SALA', 'VENDEDOR', 'MESA', 'JUNCAOMESA', 'MESAJUNCAO', 'VENDAREST', 'COMANDAVEN', 'ITCOMANDAVEN', 'MESARESERVA', 'ROTFABLOCAL', 'PRSUBGRPROD', 'PRODUTOSEG', 'LOGTRANSFOS', 'EMPRESA', 'GRUPOPER', 'FAMILIASALDO', 'FAMSALDOFILI', 'FAMSALDOPROD', 'EXTRATOCONS', 'AUTGRUPOP', 'RESERVAMESA', 'LOGOPERFOS', 'SALDOCONS', 'ENDEFILI', 'MUNICIPIO', 'PRODRALIMENT', 'RALIMENT', 'IMPRESSORA', 'IMPRESSOOPER', 'SERVICO', 'SERVTURCAIXA', 'PRODSERVTCON', 'PRODTURCAIXA', 'TIPOCONS', 'COMANDAFOS', 'CAIXAPERS', 'IMPFISPERS', 'PRODBLOQVND', 'GRUPROMOCPROD', 'GRUPROMOC', 'PRODGRUPROMOC', 'GRUPROMOCPRFIL', 'ITEMVENDAEST', 'DESCROTEIRO', 'DESCROTLOCAL', 'ITCOMANDAEST', 'DESGRUPROMOCPR', 'DESGRUPROMPRFIL', 'LOGACESSO', 'DOCNFISCECF', 'PRODMODFILI', 'PARAMSENHA', 'CONTROLSENHA', 'PAIS', 'ESTADO', 'INSCRESTAD', 'ARQMAGNETICO', 'POSESTATU', 'SETOR', 'BAIRRO', 'MOVCAIXADLV', 'REGIAOMUNI', 'COLLAYOUTIMP', 'LOGCATRACA', 'LOGCATRACAPK', 'FRMTCOLLAY', 'CONSUMIFILIAL', 'TIPOSANGRIA', 'PEDIDOFOS', 'ITPEDIDOFOS', 'LIVROMAGNETICO', 'CAMPANHA', 'ITFIDELIDADE', 'PARAMPRODFILI', 'MAPIMPRLOJA', 'IMPRLOJA', 'FILICAMPANHA', 'CEP', 'FILIALCEP', 'TIPOCONSFILI', 'DESCQTDESUB', 'PRODCAMPANHA', 'PARAMEMPRESA', 'INUTILIZANFCE', 'ARQCAT52', 'REGISTROMESA', 'MOVPONTOCONS', 'VOUCHERVND', 'BRINDECAMPANHA', 'ESTORNOVND', 'BENEFICIOCAMP', 'PRODBENECAMP', 'MOVBENEFICIOCONS', 'BENEFICIOFOS', 'MOVBENEFICIOCTR', 'WEBSERVICE', 'PRODAMBIENTE', 'CORPEDIDO', 'SETORPRODUTO', 'LOGIMPTABFID', 'SETORPRODUTOFIL', 'ACESSOFM', 'CHAMADAWAITER', 'SETORFILIAL', 'ITPEDIDOFOSPAI', 'OBSITEMVENDA', 'OBSITCOMANDAVEN', 'OBSITEMVENDAEST', 'OBSITCOMANDAEST', 'SETORPRODOBS', 'ITPEDIDOFOSREL', 'ITCMDVENORIG', 'PEDIDOALT', 'ENDEVENDE', 'COMANDACATRACA', 'SETORPRODINTER', 'MOVCAIXAMOB', 'ARQUIVOS', 'LAYOUTTECLAKDS', 'SETORLOJA', 'INTEGRACAO', 'TIPORECEINTE', 'KDSOPERACAOTEMP', 'PRODFILI', 'ITPEDIDOFOSEST', 'ITHRCOMANDA', 'CARTCREDCONS', 'CHECKINMESPOS', 'CTRLBAIXATAB', 'CAMPANHAPROMO', 'COMBINAPROD', 'PROMOCAOCOMBTMP', 'TIPOCONSLOJA', 'LOJAGRUPOOCORR', 'CATRACA', 'POS', 'FOSEXPEXECUTA', 'PROMOCAOCOMBAUX', 'SENHAPED', 'WAITERORDERS', 'POSVENDAREST', 'MOVPONTOCONSAUX', 'KDSMENSAGEM', 'KDSMSGDIAS', 'SETORFILIALMSG', 'PRODOBRIGOCOR', 'GRUPOBRIGOCOR', 'FOSSINCEXECUTA', 'RELACCODSSL', 'SUGESTAOVENDA', 'SUGESTAOITEM', 'CTRLDELETETAB', 'COMANDAVENTEMP', 'SALDMINCLICCUS', 'CONFIGINTCAT', 'BASECALC', 'BASECALCTPOPER', 'LOGSINCDLV', 'TIPOCONSRECEB', 'ITVENDADES', 	   'ITCOMANDAVENDES', 'PRODSUBSIFILI', 'CONTROLPOSVEN', 'PRODEXTERNO', 'EXTRATOCONSCANC', 'ITCMDESTORIG', 'CONFTELACAIXA', 'CUPOMDESCFOS', 'PRODCUPOMDESC', 'FILIALCUPOMDESC', 'USOCUPOMDESCFOS', 'CADBIOMETRIA', 'CAMPCOMPGANHE', 'VGCAMPCOMPGANHE', 'PRCAMPCOMPGANHE', 'LOGPEDIDOTAA', 'TABEPRECGER', 'TABEVENDGER', 'ITEMPRECOGER', 'FILITABGER', 'ITEMPRECODIAGER', 'BRCAMPCOMPGANHE', 'CARTDIGIT'`;
        this.CONSTRAINT_NAMES = `'PK_TIPOCONSCLI','PK_CONSUMIDOR','PK_CLIENFILIAL','PK_PRODLOJA','PK_GRUPPROD','PK_GRUPOCOR','PK_OCORRENCIA','PK_PRODOCORRE','PK_FERIFILI','PK_NOVOCODIGO','PK_IMPOSTO','PK_TABEPREC','PK_TABEVEND','PK_PARAMGERAL','PK_UNIDMEDIDA','PK_TIPORECE','PK_OPERADOR','PK_OPERGRUPOP','PK_FILIAL','PK_FILIOPER','PK_CAIXA','PK_CLIENTE','PK_LOJA','PK_CONFTELA','PK_PRODUTO','PK_ITEMPRECO','PK_MOVINDICE','PK_PARAVEND','PK_ROTFABRICA','PK_ALIQIMPFIS','PK_ITEMPRECODIA','PK_ITMENUCONFTE','PK_CDBARRAPROD','PK_TURCAIXA','PK_VENDA','PK_REDUCAOZ','PK_MOVCAIXA','PK_ITEMVENDA','PK_MOVICLIE','PK_IMPOSTOREDZ','PK_TOTNFISCREDZ','PK_FORMPGTOREDZ','PK_ITVENDAIMPOS','PK_ITVENDACAN','PK_COMANDACXA','PK_ITCOMANDACXA','PK_SALA','PK_VENDEDOR','PK_MESA','PK_JUNCAOMESA','PK_MESAJUNCAO','PK_VENDAREST','PK_COMANDAVEN','PK_ITCOMANDAVEN','PK_MESARESERVA','PK_ROTFABLOCAL','PK_PRSUBGRPROD','PK_PRODUTOSEG','PK_LOGTRANSFOS','PK_EMPRESA','PK_GRUPOPER','PK_FAMILIASALDO','PK_FAMSALDOFILI','PK_FAMSALDOPROD','PK_EXTRATOCONS','PK_AUTGRUPOP','PK_RESERVAMESA','PK_LOGOPERFOS','PK_SALDOCONS','PK_ENDEFILI','PK_MUNICIPIO','PK_PRODRALIMENT','PK_RALIMENT','PK_IMPRESSORA','PK_IMPRESSOOPER','PK_SERVICO','PK_SERVTURCAIXA','PK_PRODSERVTCON','PK_PRODTURCAIXA','PK_TIPOCONS','PK_COMANDAFOS','PK_CAIXAPERS','PK_IMPFISPERS','PK_PRODBLOQVND','PK_GRUPROMOCPROD','PK_GRUPROMOC','PK_PRODGRUPROMOC','PK_GRUPROMOCPRFIL','PK_ITEMVENDAEST','PK_DESCROTEIRO','PK_DESCROTLOCAL','PK_ITCOMANDAEST','PK_DESGRUPROMOCPR','PK_DESGRUPROMPRFIL','PK_LOGACESSO','PK_DOCNFISCECF','PK_PRODMODFILI','PK_PARAMSENHA','PK_CONTROLSENHA','PK_PAIS','PK_ESTADO','PK_INSCRESTAD','PK_ARQMAGNETICO','PK_POSESTATU','PK_SETOR','PK_BAIRRO','PK_MOVCAIXADLV','PK_REGIAOMUNI','PK_COLLAYOUTIMP','PK_LOGCATRACA','PK_LOGCATRACAPK','PK_FRMTCOLLAY','PK_CONSUMIFILIAL','PK_TIPOSANGRIA','PK_PEDIDOFOS','PK_ITPEDIDOFOS','PK_LIVROMAGNETICO','PK_CAMPANHA','PK_ITFIDELIDADE','PK_PARAMPRODFILI','PK_MAPIMPRLOJA','PK_IMPRLOJA','PK_FILICAMPANHA','PK_CEP','PK_FILIALCEP','PK_TIPOCONSFILI','PK_DESCQTDESUB','PK_PRODCAMPANHA','PK_PARAMEMPRESA','PK_INUTILIZANFCE','PK_ARQCAT52','PK_REGISTROMESA','PK_MOVPONTOCONS','PK_VOUCHERVND','PK_BRINDECAMPANHA','PK_ESTORNOVND','PK_BENEFICIOCAMP','PK_PRODBENECAMP','PK_MOVBENEFICIOCONS','PK_BENEFICIOFOS','PK_MOVBENEFICIOCTR','PK_WEBSERVICE','PK_PRODAMBIENTE','PK_CORPEDIDO','PK_SETORPRODUTO','PK_LOGIMPTABFID','PK_SETORPRODUTOFIL','PK_ACESSOFM','PK_CHAMADAWAITER','PK_SETORFILIAL','PK_ITPEDIDOFOSPAI','PK_OBSITEMVENDA','PK_OBSITCOMANDAVEN','PK_OBSITEMVENDAEST','PK_OBSITCOMANDAEST','PK_SETORPRODOBS','PK_ITPEDIDOFOSREL','PK_ITCMDVENORIG','PK_PEDIDOALT','PK_ENDEVENDE','PK_COMANDACATRACA','PK_SETORPRODINTER','PK_MOVCAIXAMOB','PK_ARQUIVOS','PK_LAYOUTTECLAKDS','PK_SETORLOJA','PK_INTEGRACAO','PK_TIPORECEINTE','PK_KDSOPERACAOTEMP','PK_PRODFILI','PK_ITPEDIDOFOSEST','PK_ITHRCOMANDA','PK_CARTCREDCONS','PK_CHECKINMESPOS','PK_CTRLBAIXATAB','PK_CAMPANHAPROMO','PK_COMBINAPROD','PK_PROMOCAOCOMBTMP','PK_TIPOCONSLOJA','PK_LOJAGRUPOOCORR','PK_CATRACA','PK_POS','PK_FOSEXPEXECUTA','PK_PROMOCAOCOMBAUX','PK_SENHAPED','PK_WAITERORDERS','PK_POSVENDAREST','PK_MOVPONTOCONSAUX','PK_KDSMENSAGEM','PK_KDSMSGDIAS','PK_SETORFILIALMSG','PK_PRODOBRIGOCOR','PK_GRUPOBRIGOCOR','PK_FOSSINCEXECUTA','PK_RELACCODSSL','PK_SUGESTAOVENDA','PK_SUGESTAOITEM','PK_CTRLDELETETAB','PK_COMANDAVENTEMP','PK_SALDMINCLICCUS','PK_CONFIGINTCAT','PK_BASECALC','PK_BASECALCTPOPER','PK_LOGSINCDLV','PK_TIPOCONSRECEB','PK_ITVENDADES', 	   'ITCOMANDAVENDES','PK_PRODSUBSIFILI','PK_CONTROLPOSVEN','PK_PRODEXTERNO','PK_EXTRATOCONSCANC','PK_ITCMDESTORIG','PK_CONFTELACAIXA','PK_CUPOMDESCFOS','PK_PRODCUPOMDESC','PK_FILIALCUPOMDESC','PK_USOCUPOMDESCFOS','PK_CADBIOMETRIA','PK_CAMPCOMPGANHE','PK_VGCAMPCOMPGANHE','PK_PRCAMPCOMPGANHE','PK_LOGPEDIDOTAA','PK_TABEPRECGER','PK_TABEVENDGER','PK_ITEMPRECOGER','PK_FILITABGER','PK_ITEMPRECODIAGER','PK_BRCAMPCOMPGANHE','PK_CARTDIGIT'`;
        this.INDEXES_LIST = `'CLIENFILIAL_02','CLIENTE_01','CLIENTE_02','CONSUMIDOR_03','EMPRESA_01','MOVCAIXA_01','MOVCAIXA_02','MOVCAIXA_03','MOVICLIE_01','MOVICLIE_02','MOVICLIE_03','MOVICLIE_04','MOVICLIE_05','MOVICLIE_DT','PRODUTO_02','PRODUTO_03','PRODUTO_04','PRODUTO_05','PRODUTO_06','PRODUTO_07','PRODUTO_08','PRODUTO_09','PRODUTO_CB','VENDA_01','VENDA_02','VENDA_03','VENDA_04','VENDA_05','VENDA_06','VENDA_07'`;

        this.FETCH_STRUCTURE_FROM_TABLE = `
            SELECT 
            TABLE_NAME,
            SUBSTR(COLUMN_NAME,1,100) AS COL_NAME,
        
            DECODE(COLUMN_NAME, 'VRIMPOPRODIT', 'DECIMAL(30,10)',
        
                DECODE(DATA_TYPE, 'CHAR',     'VARCHAR(1)',
                                    'DATE',     'DATETIME',
                                    'LONG',     'TEXT',
                                    'LONG RAW', 'IMAGE',
                                    'BLOB'    , 'IMAGE',
                                    'CLOB'    , DECODE(${this.TABLE_NAMES}, 'KDSOPERACAOTEMP', 'VARCHAR(MAX)',
                                                                    'WAITERORDERS'   , 'VARCHAR(MAX)',
                                                                    'ARQUIVOS'       , 'VARCHAR(MAX)',
                                                                                    'IMAGE'),
                                    'FLOAT',    'DECIMAL(30,3)',
                                    'NUMBER',   DECODE(DATA_SCALE, 0, DECODE(DATA_PRECISION, 0, 'DOUBLE PRECISION',
                                                                                                DECODE(DATA_PRECISION, 1,  'SMALLINT',
                                                                                                                    2,  'SMALLINT',
                                                                                                                    3,  'SMALLINT',
                                                                                                                    4,  'SMALLINT',
                                                                                                                    5,  'SMALLINT',
                                                                                                                    6,  'INT',
                                                                                                                    7,  'INT',
                                                                                                                    8,  'INT',
                                                                                                                    9,  'INT',
                                                                                                                    10, 'INT',
                                                                                                                        'DOUBLE PRECISION')),
                                                                    'DOUBLE PRECISION'),
                                    'VARCHAR2', DECODE(SIGN(DATA_LENGTH - 999), 1, 'VARCHAR(MAX)', 'VARCHAR('||TO_CHAR(DATA_LENGTH)||')'),
                                    DATA_TYPE)
                ) AS FIELD_TYPE,
            DECODE(NULLABLE,'Y','NULL','NOT NULL') AS NULLABLE,
            DATA_DEFAULT AS COL_DEFAULT,
            NVL((select SYS_CONTEXT('nrorg_ctx','nrorg') as NRORG from dual), '0001') AS NRORG
            FROM USER_TAB_COLUMNS
            WHERE 
            -- OWNER = :OWNER AND 
            TABLE_NAME IN (${this.TABLE_NAMES})
            ORDER BY TABLE_NAME, COLUMN_ID, COLUMN_NAME
        `;

        this.FETCH_CONSTRAINTS = `
            SELECT 
                A.TABLE_NAME,
                A.CONSTRAINT_NAME,
                SUBSTR(A.R_CONSTRAINT_NAME,4,100) AS R_CONSTRAINT_NAME,
                SUBSTR(B.COLUMN_NAME,1,100) AS COL_NAME,
                SUBSTR(A.CONSTRAINT_NAME,4,100) AS R_CONSTRAINT_NAME
            FROM 
                USER_CONSTRAINTS A, USER_CONS_COLUMNS B
            WHERE 
                -- A.OWNER = :OWNER AND 
                A.TABLE_NAME IN (${this.TABLE_NAMES})
                AND A.CONSTRAINT_TYPE = 'P'
                AND A.OWNER = B.OWNER
                AND A.TABLE_NAME = B.TABLE_NAME
                AND A.CONSTRAINT_NAME = B.CONSTRAINT_NAME
                --AND A.R_CONSTRAINT_NAME IN (${this.CONSTRAINT_NAMES})
            ORDER BY 
                A.TABLE_NAME, A.CONSTRAINT_NAME, B.POSITION
        `;
        this.FETCH_PK_BY_INDEX = `
            SELECT 
                TABLE_NAME, SUBSTR(COLUMN_NAME,1,100) AS COL_NAME
            FROM 
                USER_IND_COLUMNS
            WHERE 
                INDEX_NAME LIKE 'PK%'
                AND TABLE_NAME IN (${this.TABLE_NAMES})
                AND COLUMN_NAME NOT LIKE 'SYS%'
            ORDER BY TABLE_NAME, COL_NAME, INDEX_NAME, COLUMN_POSITION
        `;

        this.FETCH_INDEX = `
            SELECT 
                INDEX_NAME, TABLE_NAME, SUBSTR(COLUMN_NAME,1,100) AS COL_NAME, DESCEND
            FROM 
                USER_IND_COLUMNS
            WHERE 
                TABLE_NAME IN (${this.TABLE_NAMES})
                AND COLUMN_NAME NOT LIKE 'SYS%'
                AND INDEX_NAME NOT LIKE '%FK'
                AND INDEX_NAME NOT LIKE 'PK%'
                AND (INDEX_NAME NOT IN (${this.INDEXES_LIST}))
            ORDER BY INDEX_NAME, COLUMN_POSITION
        `;
    };

    getStructure(app, params) {
        return app.service.OracleService.connect().then(sql => {
            return app.service.OracleService.fetch(this.FETCH_STRUCTURE_FROM_TABLE, params);
        })
    }

    getConstraints(app, params) {
        return app.service.OracleService.connect().then(sql => {
            return app.service.OracleService.fetch(this.FETCH_CONSTRAINTS, params);
        })
    }

    getConstraintsFromIndexes(app, params) {
        return app.service.OracleService.connect().then(sql => {
            return app.service.OracleService.fetch(this.FETCH_PK_BY_INDEX, params);
        })
    }

    getIndexes(app, params) {
        return app.service.OracleService.connect().then(sql => {
            return app.service.OracleService.fetch(this.FETCH_INDEX, params);
        })
    }
}

module.exports = new StructureModel();