const OracleService = require('../service/OracleService');

class updaterModel {
  constructor() {
    /**
     * UPDATER
     */
    // SELECT * FROM FILIAL F INNER JOIN
    // UPDATERSISTEMAS UPS ON (F.CDFILIAL = UPS.CDFILIAL) INNER JOIN
    // UPDATERVERSAO UPV ON (UPS.IDUPDATERSISTEMAS = UPV.IDUPDATERSISTEMAS)
    this.GET_UPDATER = `
      SELECT
      F.CDFILIAL,
      F.NMFILIAL,
      UPS.*,
      EN.SGESTADO
      FROM
        UPDATERSISTEMAS UPS INNER JOIN
        FILIAL F ON (F.CDFILIAL = UPS.CDFILIAL) INNER JOIN
        ENDEFILI EN ON (F.CDFILIAL = EN.CDFILIAL)
      WHERE EN.IDTPENDEFILI = 'P'
    `;

    /**
     * UPDATERSISTEMAS
     */
    this.GET_UPDATERSISTEMAS = `
     SELECT * FROM UPDATERSISTEMAS
      WHERE NOME = :NOME
   `;

    this.GET_FULL_UPDATERSISTEMAS = `
     SELECT IDUPDATERSISTEMAS, DEVOPSID, SISTEMASSTATUS, CDFILIAL FROM UPDATERSISTEMAS
   `;

    /**
     * UPDATERVERSAO
     */
    this.GET_UPDATERVERSAO = `
     SELECT * FROM UPDATERVERSAO
      WHERE IDUPDATERSISTEMAS = :IDUPDATERSISTEMAS AND UPVERSTATUS = 0
   `;

    this.SET_UPDATERVERSAO = `
      INSERT INTO UPDATERVERSAO
        (IDUPDATERSISTEMAS, CDOPERADOR, UPVERDATA, UPVERSTATUS)
        VALUES (:IDUPDATERSISTEMAS, :CDOPERADOR, :UPVERDATA, :UPVERSTATUS)
   `;

   this.SET_DOWNGRADEVERSAO = `
      INSERT INTO UPDATERVERSAO
        (IDUPDATERSISTEMAS, CDOPERADOR, UPVERDATA, UPVERSTATUS)
        VALUES (:IDUPDATERSISTEMAS, :CDOPERADOR, :UPVERDATA, :UPVERSTATUS)
   `;

    /**
     * Histórico
     */
    this.GET_UPDATER_HISTORICO = `
      SELECT OP.NMOPERADOR, OP.CDOPERADOR, UPR.*, UPS.*, UPV.*
        FROM FILIAL F INNER JOIN
          UPDATERSISTEMAS UPS ON (F.CDFILIAL = UPS.CDFILIAL) INNER JOIN
          UPDATERVERSAO UPV ON (UPS.IDUPDATERSISTEMAS = UPV.IDUPDATERSISTEMAS) INNER JOIN
          OPERADOR OP ON (UPV.CDOPERADOR = OP.CDOPERADOR)
    `;
    /**
     * Histórico
     */
    this.GET_UPDATER_V_ATUAL = `
      SELECT
          F.CDFILIAL,
          F.NMFILIAL,
          OP.NMOPERADOR,
          OP.CDOPERADOR,
          UPS.*,
          UPV.*
        FROM FILIAL F INNER JOIN
          UPDATERSISTEMAS UPS ON (F.CDFILIAL = UPS.CDFILIAL) INNER JOIN
          UPDATERVERSAO UPV ON (UPS.IDUPDATERSISTEMAS = UPV.IDUPDATERSISTEMAS) INNER JOIN
          OPERADOR OP ON (UPV.CDOPERADOR = OP.CDOPERADOR)

        WHERE
          UPS.IDUPDATERSISTEMAS = :IDUPDATERSISTEMAS AND
          (UPV.UPVERSTATUS = 0 OR UPV.UPVERSTATUS = 3) AND
          ROWNUM <= :MAX_ROW
        ORDER BY UPV.IDUPDATERVERSAO DESC
   `;

    this.GET_UPDATER_V_ALL = `
      SELECT
          F.CDFILIAL,
          F.NMFILIAL,
          OP.NMOPERADOR, OP.CDOPERADOR, UPS.*, UPV.*
        FROM FILIAL F INNER JOIN
          UPDATERSISTEMAS UPS ON (F.CDFILIAL = UPS.CDFILIAL) INNER JOIN
          UPDATERVERSAO UPV ON (UPS.IDUPDATERSISTEMAS = UPV.IDUPDATERSISTEMAS) INNER JOIN
          OPERADOR OP ON (UPV.CDOPERADOR = OP.CDOPERADOR)

        WHERE
          UPS.IDUPDATERSISTEMAS = :IDUPDATERSISTEMAS AND
          UPS.CDFILIAL = :CDFILIAL AND
          ROWNUM <= :MAX_ROW
        ORDER BY UPV.IDUPDATERVERSAO DESC
   `;

   /**
    * Retorna os sistemas a serem atualizados para cilial cdFilial
    */
   this.GET_UPDATER_ESPERA_ALL = `
   SELECT UPS.APLICACAO, UPV.IDUPDATERVERSAO, UPS.IDUPDATERSISTEMAS, UPS.DIRETORIO
      FROM
        FILIAL F INNER JOIN
        UPDATERSISTEMAS UPS ON (F.CDFILIAL = UPS.CDFILIAL) INNER JOIN
        UPDATERVERSAO UPV ON (UPS.IDUPDATERSISTEMAS = UPV.IDUPDATERSISTEMAS) INNER JOIN
        OPERADOR OP ON (UPV.CDOPERADOR = OP.CDOPERADOR)

      WHERE
        F.CDFILIAL = :cdfilial AND
        UPV.UPVERSTATUS = 0 AND
        UPS.DIRETORIO IS NOT NULL
      GROUP BY UPS.APLICACAO, UPV.IDUPDATERVERSAO, UPS.IDUPDATERSISTEMAS, UPS.DIRETORIO
   `;

   /**
    * Retorna os sistemas a terem downgrade para cilial cdFilial
    */
   this.GET_DOWNGRADE_ESPERA_ALL = `
   SELECT UPS.APLICACAO, UPV.IDUPDATERVERSAO, UPS.IDUPDATERSISTEMAS, UPS.DIRETORIO
      FROM
        FILIAL F INNER JOIN
        UPDATERSISTEMAS UPS ON (F.CDFILIAL = UPS.CDFILIAL) INNER JOIN
        UPDATERVERSAO UPV ON (UPS.IDUPDATERSISTEMAS = UPV.IDUPDATERSISTEMAS) INNER JOIN
        OPERADOR OP ON (UPV.CDOPERADOR = OP.CDOPERADOR)

      WHERE
        F.CDFILIAL = :cdfilial AND
        UPV.UPVERSTATUS = 3 AND
        UPS.DIRETORIO IS NOT NULL
      GROUP BY UPS.APLICACAO, UPV.IDUPDATERVERSAO, UPS.IDUPDATERSISTEMAS, UPS.DIRETORIO
   `;

   this.UPDATE_UPDATER = `
      UPDATE UPDATERVERSAO
        SET UPVERSTATUS = :UPVERSTATUS
      WHERE IDUPDATERVERSAO = :IDUPDATERVERSAO
   `;

   this.UPDATE_UPDATERSISTEMA_ATUAL = `
      UPDATE UPDATERSISTEMAS
        SET UPSISVERATUAL = :UPSISVERATUAL
      WHERE IDUPDATERSISTEMAS = :IDUPDATERSISTEMAS
   `;

   this.SET_UPDATERSISTEMAS = `
    INSERT INTO UPDATERSISTEMAS
                (CDFILIAL,   DEVOPSID,  SISTEMASSTATUS,  APLICACAO,  DIRETORIO)
         VALUES (:CDFILIAL, :DEVOPSID, :SISTEMASSTATUS, :APLICACAO, :DIRETORIO)
  `;

   this.SET_UPDATERSISTEMAS_CANCELED = `
      UPDATE UPDATERSISTEMAS
         SET SISTEMASSTATUS = 2
       WHERE DEVOPSID = :DEVOPSID
         AND CDFILIAL = :CDFILIAL
  `;

   this.GET_PRODUCT_PENDING_EVENTS = `
      SELECT 
        * 
      FROM 
        UPDATEREVENTOS 
      WHERE 
        CDFILIAL = :P_CDFILIAL AND 
        CDPRODUCTID = :P_CDPRODUCTID AND 
        IDSTEVENTO IN ('INSTALACAO_PENDENTE', 'REMOCAO_PENDENTE')
  `;

   this.GET_PRODUCT_UPDATER_EVENT_BY_EVENT_ID = `
      SELECT 
        * 
      FROM 
        UPDATEREVENTOS 
      WHERE 
        CDFILIAL = :P_CDFILIAL AND 
        CDPRODUCTID = :P_CDPRODUCTID AND 
        IDSTEVENTO = :P_IDSTEVENTO
  `;

   this.GET_PRODUCT_IN_PROGRESS_EVENTS = `
      SELECT 
        * 
      FROM 
        UPDATEREVENTOS 
      WHERE 
        CDFILIAL = :P_CDFILIAL AND 
        CDPRODUCTID = :P_CDPRODUCTID AND 
        IDSTEVENTO IN ('INSTALACAO_EM_CURSO', 'REMOCAO_EM_CURSO')
  `;

   this.GET_EVENTS_BY_UNIT = `
      SELECT 
        * 
      FROM 
        UPDATEREVENTOS 
      WHERE 
        CDFILIAL = :P_CDFILIAL AND 
        IDSTEVENTO IN ('INSTALACAO_PENDENTE', 'REMOCAO_PENDENTE', 'INSTALACAO_EM_CURSO', 'REMOCAO_EM_CURSO')
  `;

   this.GET_IN_PROGRESS_EVENTS = `
      SELECT 
        * 
      FROM 
        UPDATEREVENTOS 
      WHERE 
        CDFILIAL = :P_CDFILIAL AND 
        IDSTEVENTO IN ('INSTALACAO_EM_CURSO', 'REMOCAO_EM_CURSO')
  `;

   this.GET_PENDING_EVENTS = `
      SELECT 
        UE.CDFILIAL,
        UE.CDEVENTO,
        UE.CDPRODUCTID,
        UE.IDSTEVENTO,
        UE.NRVERSAO,
        UE.IDCRIARVERSAO,
        UE.DTINCLUSAO,
        UPV.DSDIRETORIO,
        UPV.IDDOWNLOADVER
      FROM 
        UPDATEREVENTOS UE
        LEFT JOIN UPDATERPRODVERSAO UPV ON (UE.CDPRODUCTID = UPV.UPDATERPRODID AND UE.NRVERSAO = UPV.NRVERSAO)
      WHERE 
        IDSTEVENTO IN ('INSTALACAO_PENDENTE', 'REMOCAO_PENDENTE')
  `;

   this.GET_PENDING_EVENTS_BY_UNIT = `
      SELECT 
        UE.CDFILIAL,
        UE.CDEVENTO,
        UE.CDPRODUCTID,
        UE.IDSTEVENTO,
        UE.NRVERSAO,
        UE.IDCRIARVERSAO,
        UE.DTINCLUSAO,
        UPV.DSDIRETORIO,
        UPV.IDDOWNLOADVER
      FROM 
        UPDATEREVENTOS UE
        LEFT JOIN UPDATERPRODVERSAO UPV ON (UE.CDPRODUCTID = UPV.UPDATERPRODID AND UE.NRVERSAO = UPV.NRVERSAO)
      WHERE 
        CDFILIAL = :P_CDFILIAL AND 
        IDSTEVENTO IN ('INSTALACAO_PENDENTE', 'REMOCAO_PENDENTE')
  `;

  this.GET_UPDATER_HISTORY_BY_EVENT_ID = `
    SELECT
      *
    FROM
      UPDATERHISTORICO
    WHERE
      CDEVENTO = :P_CDEVENTO AND
      IDSTEVENTO = :P_IDSTEVENTO
  `;

   this.APPEND_UPDATER_HISTORY = `
      INSERT INTO UPDATERHISTORICO (
        CDFILIAL,
        CDHISTORICO,
        CDEVENTO,
        CDOPERADOR,
        CDUUID,
        CDPRODUCTID,
        NMPRODUCT,
        IDSTEVENTO,
        NRVERSAOATUAL,
        NRVERSAOALVO,
        IDCRIARVERSAO,
        DTINCLUSAO,
        DTULTATU
      ) VALUES (
        :P_CDFILIAL,
        :P_CDHISTORICO,
        :P_CDEVENTO,
        :P_CDOPERADOR,
        :P_CDUUID,
        :P_CDPRODUCTID,
        :P_NMPRODUCT,
        :P_IDSTEVENTO,
        :P_NRVERSAOATUAL,
        :P_NRVERSAOALVO,
        :P_IDCRIARVERSAO,
        SYSDATE,
        SYSDATE
      )
    `;

   this.INSERT_PENDING_EVENT = `
      INSERT INTO UPDATEREVENTOS (
        CDFILIAL,
        CDEVENTO,
        CDUUID,
        CDPRODUCTID,
        IDSTEVENTO,
        NRVERSAO,
        IDCRIARVERSAO,
        DTINCLUSAO,
        DTULTATU
      ) VALUES (
        :P_CDFILIAL,
        :P_CDEVENTO,
        :P_CDUUID,
        :P_CDPRODUCTID,
        :P_IDSTEVENTO,
        :P_NRVERSAO,
        :P_IDCRIARVERSAO,
        SYSDATE,
        SYSDATE
      )
    `;

   this.UPDATE_EVENT_IN_PROGRESS = `
      UPDATE UPDATEREVENTOS
      SET
        IDSTEVENTO = :P_IDSTEVENTO,
        DTULTATU = SYSDATE
      WHERE
        CDEVENTO = :P_CDEVENTO
    `;

   this.CANCEL_UNIT_EVENTS = `
      UPDATE 
        UPDATEREVENTOS
      SET
        IDSTEVENTO = 'CANCELADO',
        DTULTATU = SYSDATE
      WHERE
        CDFILIAL = :P_CDFILIAL
    `;
  }

  getProductUpdaterEventByEventId(params) {
    return OracleService.connect().then(sql => {
      return OracleService.fetchAssoc(this.GET_PRODUCT_UPDATER_EVENT_BY_EVENT_ID, params);
    });
  };

  getUpdaterHistoryByEventId(params) {
    return OracleService.connect().then(sql => {
      return OracleService.fetchAssoc(this.GET_UPDATER_HISTORY_BY_EVENT_ID, params);
    });
  };

  getProductPendingEvents(params) {
    return OracleService.connect().then(sql => {
      return OracleService.fetchAssoc(this.GET_PRODUCT_PENDING_EVENTS, params);
    });
  };

  getProductInProgressEvents(params) {
    return OracleService.connect().then(sql => {
      return OracleService.fetchAssoc(this.GET_PRODUCT_IN_PROGRESS_EVENTS, params);
    });
  };

  getEventsByUnit(params) {
    return OracleService.connect().then(sql => {
      return OracleService.fetchAssoc(this.GET_EVENTS_BY_UNIT, params);
    });
  };

  getInProgressEvents(params) {
    return OracleService.connect().then(sql => {
      return OracleService.fetchAssoc(this.GET_IN_PROGRESS_EVENTS, params);
    });
  };

  getPendingEvents() {
    return OracleService.connect().then(sql => {
      return OracleService.fetchAssoc(this.GET_PENDING_EVENTS);
    });
  };

  getPendingEventsByUnit(params) {
    return OracleService.connect().then(sql => {
      return OracleService.fetchAssoc(this.GET_PENDING_EVENTS_BY_UNIT, params);
    });
  };

  appendUpdaterHistory(params) {
    OracleService.execute(this.APPEND_UPDATER_HISTORY, params);
  };

  insertPendingEvent(params) {
    OracleService.execute(this.INSERT_PENDING_EVENT, params);
  };

  updateEventInProgress(params) {
    OracleService.execute(this.UPDATE_EVENT_IN_PROGRESS, params);
  };
  
  cancelUnitEvents(params) {
    OracleService.execute(this.CANCEL_UNIT_EVENTS, params);
  };

  getUpdaterVersao() {
    return OracleService.connect().then(() => {
      return OracleService.fetchAssoc(this.GET_UPDATER);
    });
  }

  getUpdaterVersaoAtual(params) {
    return OracleService.connect().then(() => {
      return OracleService.fetchAssoc(this.GET_UPDATER_V_ATUAL, params);
    });
  }

  getUpdaterVersaoAll(params) {
    return OracleService.connect().then(() => {
      return OracleService.fetchAssoc(this.GET_UPDATER_V_ALL, params);
    });
  }

  /**
   * @author Daniel Souza <daniel.souza@teknisa.com>
   * @param {*} params {cdfilial: 9999}
   * @returns Lista de Sistemas a serem atualizados na filial cdFilial
   */
  getVersaoDisponivel(params) {
    return OracleService.getNewConnection().then(() => {
      return OracleService.fetchAssoc(this.GET_UPDATER_ESPERA_ALL, params);
    });
  }

  /**
   * @author Daniel Souza <daniel.souza@teknisa.com>
   * @param {*} params {cdfilial: 9999}
   * @returns Lista de Sistemas a serem atualizados na filial cdFilial
   */
   getVersaoDowngrade(params) {
    return OracleService.getNewConnection().then(() => {
      return OracleService.fetchAssoc(this.GET_DOWNGRADE_ESPERA_ALL, params);
    });
  }

  updateVersaoDisponivel(params) {
    return OracleService.getNewConnection().then(() => {
      return OracleService.execute(this.UPDATE_UPDATER, params);
    });
  }

  updateVersaoAtual(params) {
    return OracleService.getNewConnection().then(() => {
      return OracleService.execute(this.UPDATE_UPDATERSISTEMA_ATUAL, params);
    });
  }

  setUpdaterVersao(params) {
    return OracleService.getNewConnection().then(() => {
      return OracleService.execute(this.SET_UPDATERVERSAO, params);
    });
  }

  setDowngradeVersao(params) {
    return OracleService.getNewConnection().then(() => {
      return OracleService.execute(this.SET_DOWNGRADEVERSAO, params);
    });
  }

  setUpdaterSistemas(params, connection) {
    return OracleService.execute(this.SET_UPDATERSISTEMAS, params, [], false, connection);
  }

  setUpdaterSistemasCanceled(params, connection) {
    return OracleService.execute(this.SET_UPDATERSISTEMAS_CANCELED, params, [], false, connection);
  }

  getFullUpdaterSistemas(connection) {
    return OracleService.execute(this.GET_FULL_UPDATERSISTEMAS, [], [], false, connection);
  }

  /**
   * @author Daniel Souza <daniel.souza@teknisa.com>
   * @param {*} params {cdfilial: 9999}
   * @returns Retorna se o sistema já tem um pedido de update
   */
   getRegistroUpdate(params) {
    return OracleService.getNewConnection().then(() => {
      return OracleService.fetchAssoc(this.GET_UPDATERVERSAO, params);
    });
  }
}

module.exports = new updaterModel();
