const OracleService = require('../service/OracleService');

class updaterProdFiliModel 
{  
  getUpdaterProdFili(updaterProdId) {
    const sql = `
      SELECT ID, CDFILIAL, NRVERSAOATUAL
        FROM UPDATERPRODFILI
       WHERE UPDATERPRODID = :UPDATERPRODID
    `;

    const params = {
      UPDATERPRODID: updaterProdId
    };

    return OracleService.fetchAssoc(sql, params);
  }

  insertUpdaterProdFili(params) {
    const sql = `
      INSERT INTO UPDATERPRODFILI
                ( UPDATERPRODID,  CDFILIAL, DTINCLUSAO, DTULTATU)
         VALUES (:UPDATERPRODID, :CDFILIAL, SYSDATE,    SYSDATE)
    `;
    return OracleService.execute(sql, params);
  }

  updateUpdaterProdFiliVersion(params) {
    const sql = `
      UPDATE 
        UPDATERPRODFILI
      SET
        NRVERSAOATUAL = :NRVERSAO
      WHERE
        CDFILIAL = :CDFILIAL AND
        UPDATERPRODID = :UPDATERPRODID
    `;
    
    return OracleService.execute(sql, params);
  }
}

module.exports = new updaterProdFiliModel();
